import paramiko

from . import idec
from . import idict
from . import ioverfunc


@idec.Retry('InitSSH', cycle=1)
def __init__(name: str, conf: idict) -> paramiko.SSHClient:
    client = paramiko.SSHClient()
    client.set_missing_host_key_policy(paramiko.AutoAddPolicy())

    for k, v in conf.items():
        setattr(client, k, v)

    client.connect(**conf)
    ioverfunc.add(client.close)

    return client


def _cmd(self, command: str) -> str:
    _stdin, stdout, _stderr = self.exec_command(command)
    return stdout.read().decode().strip()


def _put_file(self, local: str, remote: str):
    return self.open_sftp().put(local, remote)


def _get_file(self, remote: str, local: str):
    return self.open_sftp.get(remote, local)


paramiko.SSHClient.cmd = _cmd
paramiko.SSHClient.put_file = _put_file
paramiko.SSHClient.get_file = _get_file
